#include "header.h"

/*
 * Open /proc/scsi/sg/device_strs and show list of 
 * devices mapped. Allow user to select one and
 * return with devicename.
 */
char *deviceSel( char *dev )
{
  /*
   * Counter
   */
  int i = 0, j, k;

  /*
   * Make space for device name 
   */
  dev = (char *) malloc( 10 * sizeof( char ) );
  
  /*
   * Show devices that can be used
   * and allow user to select one.
   */
  printf( "Select device to test:\n" );

  for( j = 0; j < 16; j++ ) 
  {
    char buf[256];

    sprintf( dev, "/dev/sg%d", j );
    i = open( dev, O_RDWR );

    if ( i > 0 )
    {
      if( inquiry( i, buf ) )
      {
        close(i);
        exit(EXIT_FAILURE);
      }

      printf( "%d: /dev/sg%d -> ", j, j );

      for( k = 8; k < 16; k++ )
        printf( "%c", (buf[k]==0)?' ':buf[k] );
      printf( "  " );

      for( k = 16; k < 32; k++ )
        printf( "%c", (buf[k]==0)?' ':buf[k] );
      printf( "  " );

      for( k = 32; k < 36; k++ )
        printf( "%c", (buf[k]==0)?' ':buf[k] );
      printf( "\n" );

      close( i );
    }
  }

  printf( "Selection: " );

  fflush( stdin );

  scanf( "%d", &j );

  sprintf( dev, "/dev/sg%d", j );

  return dev;
}
